<?php
/*This software is governed by a creative commons license whose terms of use are explained in the readme file */
/***************************************
*  SETTING THE PARAMETERS OF THE DEFAULT ALBUM
****************************************/
/*It's preferable not to modify these settings unless they are common to all albums. To modify the settings for a particular album, override the settings you want to modify (see sample album for an illustration).*/

/* $lang is the language of the XHTML document: ("en", "fr", "es", "eo", etc...).  A number of language files is provided in the languages directory. You can add your own as necessary observing the same syntax conventions. The web pages use $charset which is set here  to  iso-8859-1  adequate for latin languages. If this charset weren't adequate, you may choose the UTF-8 charset for instance and use a UTF-8 editor to edit your files */
$lang = 'en';
$charset = 'iso-8859-1';

/* $lang_title_album is the title of the viewPicture.php and viewDiaporama.php pages ; the title of viewPicture.php is the concatenation of $lang_title_album with the picture name to be viewed. Set it in your specific album description file which will override the value found here.*/
$lang_title_album = "picture album";


/* set $index_thumbnails to noindex if you do not want the thumbnail pages (displayed by viewAlbum.php)of your album to be indexed by search engines. If you want the individual pictures to be indexed, the option follow must also be present.*/
$index_thumbnails = 'index, follow';

/* $meta_description contains the value of the content attribute of the meta tag description of viewAlbum.php, it's important to set this to a proper value if you want your page to be indexed by search engines. Set it in your specific album description.*/
$meta_description ="";


/* set $index_pictures to index if you want all the individual pictures (displayed by viewPicture.php) of your album to be indexed by search engines provided $index_thumbnails has the follow option. (Notice that  there's a page for every single picture contained in your album). */
$index_pictures = 'noindex, nofollow';

/* $theme refers to the trailing part of the themes directory which embodies the theme to be used.*/
$theme = 'default';

/*  $pic_info_file refers to  the relative name (with respect to the album directory) of the optional file which contains the picture names and optional captions.*/
$pic_info_file = "";

/* set thumbnails to true if you want to display them or false otherwise*/
$thumbnails = false;

/* change $max_thumbnails_page to the number of thumbnails you want on a page*/
$max_thumbnails_page = 12;

/* $delay is the initial value  in seconds for the pause between two slides in a slideshow */
$delay = 4;

/* for the fading effect between the newly loaded image and the previous image in the picture window, set these parameters. The fading will last 100/$step X $pause. $step must be a dividor of 100*/
$step = 2;
$pause = 7; /*milliseconds*/

/* should the id of the body element of viewAlbum be identified, define its value as $body_id*/
$body_id = '';

/*Once installation is done and works correctly, it is better to set display_errors to 0, log_errors to 1, and error_log to a filename between quotes writable by the web server*/

(defined("E_STRICT")) ? @error_reporting(E_ALL | E_STRICT) : @error_reporting(E_ALL);
@ini_set("display_errors", 1);
@ini_set("log_errors", 0);
@ini_set("error_log", '');
?>
