<?php
/*This software is governed by a creative commons license whose terms of use are explained in the readme file */

/* common code to viewAlbum.php, viewDiaporama.php, and viewPicture.php */
/* *************************************
*  GLOBAL VARIABLES
****************************************/
$version = "PJGallery1.3.2";
$debug = 0;
$root_css = ''; //root-based name of the css file according to the selected theme
$root_css_print = ''; //root-based name of the css print style file according to the selected theme
$abs_album_desc = ''; //the absolute  name of the file describing the album
$root_album_desc = ''; //the (document) root  name of the file describing the album
$album_dir = ''; //the base name of the directory that contains the album to be displayed
$abs_album_dir = ''; //the absolute name of the directory containg the album
$root_album_dir = ''; //the root name of the directory containg the album

$pic_info = array (array ()); //$pic_info[j][0] = name of the jth image; $pic_info[j][1] = image caption
$nb_pictures = 0; //the total number of images in the album.
$err_msg = "<p class='error'>This album has no pictures</p>";


/* *************************************
*  FUNCTIONS
****************************************/

function debug($format, $param = '') { 
	global $debug;
	if (isset($_GET['debug']) || $debug)
		printf("DEBUG:" . $format . "<br /><br />", $param); 
}

function sanitize_document_root(){
	/*remove trailing slash if any */
	$s = $_SERVER['DOCUMENT_ROOT'];
	str_replace('\\', '/', $s);
	if ($s[strlen($s)-1] == '/'){
		$_SERVER['DOCUMENT_ROOT'] = substr($s, 0, strlen($s)-1);
	}
}

function abs_name($input) {
  /*$input is either a relative name or a root-based name. The function returns the absolute file system name. The function handles the  Windows file naming convention and assumes that $_SERVER['DOCUMENT_ROOT'] doesn't contain a trailing /.*/
  if (strpos($input, '/') === 0)
    return $_SERVER['DOCUMENT_ROOT']. $input;
  else{
	return dirname(str_replace('\\', '/', $GLOBALS['call_FILE'])) . '/' . $input;
  }
}
function is_under_root($abs_name) {
	/*security check to ensure that $abs_name lies under the wb server root*/
  if (strpos(str_replace('\\', '/', realpath($abs_name)), $_SERVER['DOCUMENT_ROOT']) === 0)
    return true;
  else
    return false;
  }

function dir_empty($dir) {
  if (is_dir($dir)) {
    $dh = opendir($dir);
    /* check if more files than . and ..*/
    $count = 0;

    while (($file = readdir($dh)) && ($count < 3)) $count += 1;
    closedir($dh);

    if ($count > 2)
      return false;
    else
      return true;
  } else
    return true;
  }

function strip_suffix($base_name) {
	/* pass parameter by reference and avoid copying */
	$array = explode('.', $base_name);
	return $array[0]; 
}

function fix_magic_quotes(){
//See if magic_quotes is enabled, and fix problems if it is
$quotes_on = (get_magic_quotes_gpc() || get_magic_quotes_runtime());

if ($quotes_on) {
  foreach ($_GET as $key => $value) {
    $_GET[$key] = stripslashes($value);
  }
}
}
/* *************************************
*  ENTRY POINT
****************************************/
fix_magic_quotes();
sanitize_document_root();
/* check the album parameter and include album variables*/
$alb_default = INSTALLDIR . '/albums/default/albumDescription.inc.php';
if (!isset($_GET['alb']))
  $_GET['alb'] = $alb_default;
$abs_album_desc = abs_name(urldecode($_GET['alb']));
debug("DOCUMENT_ROOT: %s", $_SERVER['DOCUMENT_ROOT']);
debug("call File: %s", $call_FILE);
debug("album query: %s", $_GET['alb']);
debug("abs album name: %s",$abs_album_desc);
debug("realpath abs album name: %s", realpath($abs_album_desc));
if (!file_exists($abs_album_desc) || !is_under_root($abs_album_desc)) {
  die($err_msg);
}
$abs_album_dir = dirname($abs_album_desc);
$album_dir = basename($abs_album_dir);
$root_album_dir = substr($abs_album_dir, strlen($_SERVER['DOCUMENT_ROOT']));
$root_album_desc = substr($abs_album_desc, strlen($_SERVER['DOCUMENT_ROOT']));
debug("root album directory: %s",$root_album_dir);
debug("root album name: %s",$root_album_desc);
include_once(abs_name($alb_default)); /*include the default album*/
include_once($abs_album_desc);/*overrides the default options by the specific album options*/
debug("album loaded");
/* load the language file */
$abs_lang_file = $_SERVER['DOCUMENT_ROOT']. INSTALLDIR . '/languages/'. $GLOBALS['lang'] . '.language.inc.php';
if (is_file($abs_lang_file))
  include_once($abs_lang_file);
debug("language file loaded");
/* set the $root_css variable*/
$root_css = INSTALLDIR . "/themes/" . $GLOBALS['theme'] . "/pjgallery.css";
$root_css_print = INSTALLDIR . "/themes/" . $GLOBALS['theme'] . "/print.css";
/* load the $pic_info array*/
if (dir_empty($abs_album_dir . '/images')) {
  die($err_msg);
}
/* Check if thumbnails to list */
if ($GLOBALS['thumbnails'] && (!is_dir($abs_album_dir . '/thumbnails') ||dir_empty($abs_album_dir . '/thumbnails')))
  $GLOBALS['thumbnails'] = false;

if (is_file($abs_album_dir . '/' . $GLOBALS['pic_info_file'])) {
  $temp_tab = file($abs_album_dir . '/' . $GLOBALS['pic_info_file']);
  $maxiter = count($temp_tab);

  for ($i = 0; $i != $maxiter; $i++) {
    $pic_info[$i] = explode(";", trim($temp_tab[$i]));
    /* the user may have forgotten the ; if there is no caption*/
    if (!isset($pic_info[$i][1]))
      $pic_info[$i][1] = '';
  }
} else { 
	/*read images  directory, if thumbnail is not available, it will be displayed as such */

  $dh = opendir($abs_album_dir . '/images');
  $i = 0;

  while ($file = readdir($dh)) {
    if (($file == '.') || ($file == '..'))
      continue;
    $pic_info[$i][0] = $file;
    $pic_info[$i][1] = "";
    $i++;
  }
  closedir($dh);
}
$nb_pictures = count($pic_info);
debug("pic_info loaded, nb pictures: %d ", $nb_pictures);
if ($nb_pictures == 0) die ($err_msg);
?>