<!doctype html
  public "-//w3c//dtd xhtml 1.0 transitional//en" "http://www.w3.org/tr/xhtml1/dtd/xhtml1-transitional.dtd">
<html xmlns = "http://www.w3.org/1999/xhtml" xml:lang = "en" lang = "en">
 <html>
  <head>
   <meta http-equiv = "content-type" content = "text/html; charset=iso-8859-1" />

   <title>PJGallery: make thumbnails</title>

   <style type = 'text/css'>
    body {
     font-size: 80%;
     font-family: verdana;
    }

    * {
     font-size: 1em;
    }

    h1 {
     font-weight: bold;
     background-color: #eee;
     border: 1px solid black;
     text-align: center;
    }

    label {
     margin-top: 5px;
     float: left;
     text-align: right;
     width: 20em;
     margin-right: 1em;
     font-weight: bold;
    }

    input {
     margin-top: 5px;
     float: left;
     width: 25em;
     text-align: left;
     background-color: #eee;
    }

    input:hover, input:focus {
     background-color: #fff;
    }

    #submitbutton {
     cursor: pointer;
     font-weight: bold;
     text-align: center;
     background-color: #9c3;
    }

    p {
     clear: both;
    }
   </style>
  </head>

  <?
  /* makethumbnails.php  file of PJGallery: make thumbnails of the appropiate size and crop if necessary */

  $imgtype = '';

  function debug($format, $param = '') {
   global $debug;

   if ($debug)
    printf("<p>DEBUG:" . $format . "</p>\n", $param);
   }

  function paint_elt($name) { return htmlentities($name, ENT_QUOTES, 'iso-8859-1'); }

  function magic_quotes() {
   //See if  magic_quotes is enabled, and fix problems if it is
   $quotes_on = (get_magic_quotes_gpc() || get_magic_quotes_runtime());

   if ($quotes_on)
    foreach ($_POST as $key => $value)$_POST[$key] = stripslashes($value);
   } //magic_quotes

  function open_image($file) {
   global $imgtype;
   /* try opening until one works */
   # JPEG:
   $im = @imagecreatefromjpeg($file);

   if ($im !== false) {
    $imgtype = 'JPEG';
    return $im;
   }

   # GIF:
   $im = @imagecreatefromgif($file);

   if ($im !== false) {
    $imgtype = 'GIF';
    return $im;
   }

   # PNG:
   $im = @imagecreatefrompng($file);

   if ($im !== false) {
    $imgtype = 'PNG';
    return $im;
   }

   # GD File:
   $im = @imagecreatefromgd($file);

   if ($im !== false) {
    return $im;
   }

   # GD2 File:
   $im = @imagecreatefromgd2($file);

   if ($im !== false) {
    return $im;
   }

   # WBMP:
   $im = @imagecreatefromwbmp($file);

   if ($im !== false) {
    return $im;
   }

   # XBM:
   $im = @imagecreatefromxbm($file);

   if ($im !== false) {
    return $im;
   }

   # XPM:
   $im = @imagecreatefromxpm($file);

   if ($im !== false) {
    return $im;
   }

   # Try and load from string:
   $im = @imagecreatefromstring(file_get_contents($file));

   if ($im !== false) {
    return $im;
   }

   return false;
   } /*open_image*/

	 
	 function sanitize_document_root(){
	/*remove trailing slash if any */
	$s = $_SERVER['DOCUMENT_ROOT'];
	str_replace('\\', '/', $s);
	if ($s[strlen($s)-1] == '/'){
		$_SERVER['DOCUMENT_ROOT'] = substr($s, 0, strlen($s)-1);
	}
	}
	
  function abs_name($input) {
/*$input is either a relative name or a root-based name. The function returns the absolute file system name. The function handles the  Windows file naming convention and assumes that $_SERVER['DOCUMENT_ROOT'] doesn't contain a trailing /.*/
   if (strpos($input, '/') === 0)
    return $_SERVER['DOCUMENT_ROOT'] . $input;
   else {
    return dirname(str_replace('\\', '/', __FILE__)) . '/' . $input;
   }
   }

  function is_under_root($abs_name) {
   /*security check to ensure that $abs_name lies under the wb server root, realpath returns blank if $abs_name is invalid*/
   if (strpos(str_replace('\\', '/', realpath($abs_name)), $_SERVER['DOCUMENT_ROOT']) === 0)
    return true;
   else
    return true;
   }

  $functions_necessary = array (
   "getimagesize",
   "imagecreatetruecolor",
   "imagecopyresized",
   "imagedestroy",
   "imagejpeg"
  );

  $error = false;
  $error_msg = "";
  /* load the default values for the form*/
  $thumbnail_quality = 75;
  $thumbnail_max_width_input = 133;
  $thumbnail_max_height_input = 100;
  $source_dir_post = '/pjgallery/albums/default/images';
  $target_dir_post = '/pjgallery/albums/default/thumbnails';
  $debug = 1;

  if (isset($_POST['actionflag'])) {
   magic_quotes();
   /*the form has been submitted: load the submitted values */
   $error_msg = '';
   $source_dir_post = $_POST['sourcedir'];
   $target_dir_post = $_POST['targetdir'];
   $thumbnail_quality = (int)$_POST['quality'];
   $thumbnail_max_width_input = (int)$_POST['width'];
   $thumbnail_max_height_input = (int)$_POST['height'];
   $debug = (int)$_POST['debug'];
   /*check source and target directory*/
	 sanitize_document_root();
   $source_dir = abs_name($source_dir_post);

   if (!file_exists($source_dir)) {
    $error = true;
    $error_msg .= $source_dir . ": the source directory doesn't exist or isn't readable<br />";
   }

   if (!is_under_root($source_dir)) {
    $error = true;
    $error_msg .= $source_dir . ": the source directory isn't under root<br />";
   }

   $target_dir = abs_name($target_dir_post);

   if (!file_exists($target_dir) || !(is_writable($target_dir))) {
    $error = true;
    $error_msg .= $target_dir . ": the target directory does't exist or is not writable <br />";
   }

   if (!is_under_root($target_dir)) {
    $error = true;
    $error_msg .= $target_dir . ": the target directory isn't under root<br />";
   }

   /* check availability of necessary functions*/
   foreach ($functions_necessary as $function_necessary) {
    if (!function_exists($function_necessary)) {
     echo "<p>{$function_necessary} is a mandatory function for using this program (GD library required): abort</p>";
     exit;
    }
   }

   if (!$error) {
    echo "<body>";

    echo ("<h1>CREATING THUMBNAILS FROM {$source_dir} TO {$target_dir}</h1>\n");
    /*do the work and exit*/
    /*loop on the source directory */
    $ds = opendir($source_dir);
		$image_properties = array();
    while ($source_file = readdir($ds)) {
     /* the thumbnail name is identical to the source image*/
     if ($source_file == '.' || $source_file == '..')
      continue;
     $target_file = "{$target_dir}/{$source_file}";
     debug("targetfile: %s", $target_file);

     if (file_exists($target_file)) {
      debug("file already existing: skip");
      continue;
     }

     if (!($source_id = open_image("{$source_dir}/{$source_file}"))) {
      debug("cannot create an image from the initial file: see absence of the function imagecreatefrom...");
      continue;
     }
		 $image_properties = getimagesize("{$source_dir}/{$source_file}");
     $source_width = $image_properties[0];
     $source_height = $image_properties[1];
     /* if vertical image: invert width and height for the output*/
     if ($source_width < $source_height) {
      $thumbnail_max_width = $thumbnail_max_height_input;
      $thumbnail_max_height = $thumbnail_max_width_input;
     } else {
      $thumbnail_max_width = $thumbnail_max_width_input;
      $thumbnail_max_height = $thumbnail_max_height_input;
     }

     /* scale and then crop if necessary, normally $scale is < 1 but it should also work if >=1 */
     $scale = max($thumbnail_max_width / $source_width, $thumbnail_max_height / $source_height);
     $thumbnail_actual_width = floor($scale * $source_width);
     $thumbnail_actual_height = floor($scale * $source_height);
     $target_id = imagecreatetruecolor($thumbnail_actual_width, $thumbnail_actual_height);

     if (function_exists('imagecopyresampled'))
      imagecopyresampled($target_id, $source_id, 0, 0, 0, 0, $thumbnail_actual_width, $thumbnail_actual_height,
        $source_width, $source_height);
     else
      imagecopyresized($target_id, $source_id, 0, 0, 0, 0, $thumbnail_actual_width, $thumbnail_actual_height,
        $source_width, $source_height);
     imagedestroy ($source_id);
     $source_id = $target_id;
     /* crop if necessary*/
     if (($thumbnail_actual_height != $thumbnail_max_height) || ($thumbnail_actual_width != $thumbnail_max_width)) {
      $target_id = imagecreatetruecolor($thumbnail_max_width, $thumbnail_max_height);
      imagecopy($target_id, $source_id, 0, 0, (int)($thumbnail_actual_width - $thumbnail_max_width) / 2,
        (int)($thumbnail_actual_height - $thumbnail_max_height) / 2, $thumbnail_max_width, $thumbnail_max_height);
      imagedestroy ($source_id);
      $source_id = $target_id;
     }

     switch ($imgtype) {
      case 'GIF':
       if (function_exists("imagegif") && imagegif($target_id, $target_file)) {
        debug("gif thumbnail created");
        break;
       }

      case 'PNG':
       if (function_exists("imagepng") && imagepng($target_id, $target_file)) {
        debug("png thumbnail created");
        break;
       }

      default:
       if (imagejpeg($target_id, $target_file, $thumbnail_quality))
        debug("jpeg thumbnail created");
       else
        debug("cannot create thumbnail jpeg");
     }
     /* Change the mode of the file so that the user can delete the file  since the web server is now the owner of the file, not the user! */
		 @chmod($target_file, 0777);
     imagedestroy ($target_id);
    } /* end while */
    closedir ($ds);

    echo "<p>End of program: OK.</p>\n";
    echo "</body></html>";
    exit;
   } /* end of the work part*/
  }  /* end of form submitted*/
  /* submit the form to user now*/

  ?>

  <body>
   <h1>PJGallery: CREATING THUMBNAILS</h1>

   <p style = "text-align:justify">
   This application creates thumbnails from (gif, png, jpeg) images in the target directory with the same name as
   found in the source directory. If a thumbnail with this name already exists, the program simply skips to the next.
   Therefore, you should destroy existing thumbnails if you want to regenerate them. The program handles both
   horizontal and vertical formats. The target directory should exist prior to the call of the program and be writable
   (see command chmod 0777 on Unix). The file is created with 0777 mode, notice that the owner of the thumbnail is not
   the user but the web server. </p>

   <?
   if ($error) {
    echo "<p style='color:red;'}>{$error_msg}</p>";
   }
   ?>

      <form name = 'parameters' action = '<?echo $_SERVER['PHP_SELF']?>' method = 'post'>
       <p>
       <label>&nbsp;</label>

       <input name = 'actionflag' type = 'hidden' value = '' />
   </p>

       <p>
       <label> source_directory(web-root based):</label>

       <input type = 'text' name = 'sourcedir' value = '<?echo paint_elt($source_dir_post);?>' />
   </p>

       <p>
       <label> target_directory(web-root based):</label>

       <input type = 'text' name = 'targetdir' value = '<?echo paint_elt($target_dir_post);?>' />
   </p>

       <p>
       <label> width for horizontal image (height for vertical image):</label>

       <input type = 'text' name = 'width' value = '<?echo paint_elt($thumbnail_max_width_input);?>' />
   </p>

       <p>
       <label> height for horizontal image (width for horizontal image):</label>

       <input type = 'text' name = 'height' value = '<?echo paint_elt($thumbnail_max_height_input);?>' />
   </p>

       <p>
       <label> quality (1-100):</label>

       <input type = 'text' name = 'quality' value = '<?echo paint_elt($thumbnail_quality);?>' />
   </p>

       <p>
       <label> debug(0,1):</label>

       <input type = 'text' name = 'debug' value = '<?echo paint_elt($debug);?>' />
   </p>

       <p>
       <label>&nbsp;</label>

       <input id = "submitbutton" type = 'submit' value = 'make thumbnails' />
   </p>
      </form>
  </body>
 </html>